N=5; %Number of stories
g=9.81; %Gravity
h=3 %Height of stories
%M-Matrix

m=diag([6116.2 6116.2 6116.2 6116.2 6116.2]);
m

%K-Matrix
for n= 1:(N-1)
    k(n,n)=(2*3*12*210*10^9*6.06*10^-6)/3^3;
end

for n=N
    k(n,n)=(3*12*210*10^9*6.06*10^-6)/3^3;
end

for n=1:(N-1)
    k(n,n+1)=-(3*12*210*10^9*6.06*10^-6)/3^3;
end

for n=1:(N-1)
    k(n+1,n)=-(3*12*210*10^9*6.06*10^-6)/3^3;
end
k
%Eigenvalues
[modes wsquare]=eig(k,m)

T=zeros(N,1);
for n=1:N
    T(n)=(sqrt(wsquare(n,n))*(1/(2*pi)))^-1;
end
T

Modes=zeros(N,N);
for i= 1:N
    for j = 1:N
        Modes(j,i)=modes(j,i)/modes(N,i);
    end
end
Modes
%Generalized mass
Mn=zeros(N,1);
for i = 1:N
    for j = 1:N
    Temp=m(j,j)*(Modes(j,i))^2;
    Mn(i,1)=Mn(i,1)+Temp;
    end
end
Mn

Lhn=zeros(N,1);

for i = 1:N
    for j = 1:N
    Temp=m(j,j)*(Modes(j,i));
    Lhn(i,1)=Lhn(i,1)+Temp;
    end
end
Lhn

%Modal Participation Factor
GamN=zeros(N,1);

for i = 1:N
    temp=Lhn(i,1)/Mn(i,1);
    GamN(i,1)=temp;
end
    
GamN

Lnteta=zeros(N,1);

for i = 1:N
    for j=1:N
        temp=144*j*m(j,j)*Modes(i,j);
        Lnteta(i,1)=temp+Lnteta(i,1);
    end
end
Lnteta

%Insert Displacement from Response Spectrum
D=[(1.992)/wsquare(1,1) (8.1)/wsquare(2,2) (7.7)/wsquare(3,3) (5.6)/wsquare(4,4) (7.59)/wsquare(5,5)]

%Story Displacements
for i= 1:N
    for j = 1:N
        u(j,i)=GamN(i)*Modes(j,i)*D(i);
    end
end

u
%SRSS Displacement
usum=zeros(N,1);
for i = 1:N
    for j = 1:N
    temp=(u(i,j))^2;
    usum(i,1)=usum(i,1)+temp;
    end
    usrss(i,1)=sqrt(usum(i,1));
end
usrss
    
    
%Acceleration from Response Spectrum
A=[1.992 8.1 7.7 5.6 7.59]
%Story Forces
for i=1:N
    for j = 1:N
        f(j,i)= GamN(i)*m(j,j)*Modes(j,i)*A(i);
    end
end
f

%Base Shear
Vb=zeros(N,1);
for i= 1:N
    for j = 1:N
        Temp=f(j,i);
        Vb(i,1)=Vb(i)+Temp;
    end
end
Vb

%Base Shear SRSS
Vbs=0;
for i = 1:N
    Temp=(Vb(i,1))^2;
    Vbs=Vbs+Temp;
end
Vbsrss=sqrt(Vbs)


Mb=zeros(N,1);
for i= 1:N
    for j = 1:N
        Temp = f(j,i)*h*j;
        Mb(i,1)=Mb(i,1)+Temp;
    end
end
Mb